// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.19.4
// source: entity.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// EntityClient is the client API for Entity service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type EntityClient interface {
	Create(ctx context.Context, in *EntityModel, opts ...grpc.CallOption) (*EntityModel, error)
	Update(ctx context.Context, in *EntityModel, opts ...grpc.CallOption) (*EntityModel, error)
	Delete(ctx context.Context, in *proto.Id64Request, opts ...grpc.CallOption) (*emptypb.Empty, error)
	GetById(ctx context.Context, in *proto.Id64Request, opts ...grpc.CallOption) (*EntityModel, error)
	Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*CountEntityResponse, error)
	GetByType(ctx context.Context, in *proto.StringRequest, opts ...grpc.CallOption) (*EntityModel, error)
	ListByParentId(ctx context.Context, in *ListByParentIdReq, opts ...grpc.CallOption) (*ListByParentIdResp, error)
}

type entityClient struct {
	cc grpc.ClientConnInterface
}

func NewEntityClient(cc grpc.ClientConnInterface) EntityClient {
	return &entityClient{cc}
}

func (c *entityClient) Create(ctx context.Context, in *EntityModel, opts ...grpc.CallOption) (*EntityModel, error) {
	out := new(EntityModel)
	err := c.cc.Invoke(ctx, "/treeMs.Entity/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *entityClient) Update(ctx context.Context, in *EntityModel, opts ...grpc.CallOption) (*EntityModel, error) {
	out := new(EntityModel)
	err := c.cc.Invoke(ctx, "/treeMs.Entity/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *entityClient) Delete(ctx context.Context, in *proto.Id64Request, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/treeMs.Entity/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *entityClient) GetById(ctx context.Context, in *proto.Id64Request, opts ...grpc.CallOption) (*EntityModel, error) {
	out := new(EntityModel)
	err := c.cc.Invoke(ctx, "/treeMs.Entity/GetById", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *entityClient) Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*CountEntityResponse, error) {
	out := new(CountEntityResponse)
	err := c.cc.Invoke(ctx, "/treeMs.Entity/Count", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *entityClient) GetByType(ctx context.Context, in *proto.StringRequest, opts ...grpc.CallOption) (*EntityModel, error) {
	out := new(EntityModel)
	err := c.cc.Invoke(ctx, "/treeMs.Entity/GetByType", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *entityClient) ListByParentId(ctx context.Context, in *ListByParentIdReq, opts ...grpc.CallOption) (*ListByParentIdResp, error) {
	out := new(ListByParentIdResp)
	err := c.cc.Invoke(ctx, "/treeMs.Entity/ListByParentId", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// EntityServer is the server API for Entity service.
// All implementations must embed UnimplementedEntityServer
// for forward compatibility
type EntityServer interface {
	Create(context.Context, *EntityModel) (*EntityModel, error)
	Update(context.Context, *EntityModel) (*EntityModel, error)
	Delete(context.Context, *proto.Id64Request) (*emptypb.Empty, error)
	GetById(context.Context, *proto.Id64Request) (*EntityModel, error)
	Count(context.Context, *emptypb.Empty) (*CountEntityResponse, error)
	GetByType(context.Context, *proto.StringRequest) (*EntityModel, error)
	ListByParentId(context.Context, *ListByParentIdReq) (*ListByParentIdResp, error)
	mustEmbedUnimplementedEntityServer()
}

// UnimplementedEntityServer must be embedded to have forward compatible implementations.
type UnimplementedEntityServer struct {
}

func (UnimplementedEntityServer) Create(context.Context, *EntityModel) (*EntityModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedEntityServer) Update(context.Context, *EntityModel) (*EntityModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedEntityServer) Delete(context.Context, *proto.Id64Request) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedEntityServer) GetById(context.Context, *proto.Id64Request) (*EntityModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetById not implemented")
}
func (UnimplementedEntityServer) Count(context.Context, *emptypb.Empty) (*CountEntityResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Count not implemented")
}
func (UnimplementedEntityServer) GetByType(context.Context, *proto.StringRequest) (*EntityModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetByType not implemented")
}
func (UnimplementedEntityServer) ListByParentId(context.Context, *ListByParentIdReq) (*ListByParentIdResp, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListByParentId not implemented")
}
func (UnimplementedEntityServer) mustEmbedUnimplementedEntityServer() {}

// UnsafeEntityServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to EntityServer will
// result in compilation errors.
type UnsafeEntityServer interface {
	mustEmbedUnimplementedEntityServer()
}

func RegisterEntityServer(s grpc.ServiceRegistrar, srv EntityServer) {
	s.RegisterService(&Entity_ServiceDesc, srv)
}

func _Entity_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(EntityModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EntityServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/treeMs.Entity/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EntityServer).Create(ctx, req.(*EntityModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Entity_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(EntityModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EntityServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/treeMs.Entity/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EntityServer).Update(ctx, req.(*EntityModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Entity_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.Id64Request)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EntityServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/treeMs.Entity/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EntityServer).Delete(ctx, req.(*proto.Id64Request))
	}
	return interceptor(ctx, in, info, handler)
}

func _Entity_GetById_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.Id64Request)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EntityServer).GetById(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/treeMs.Entity/GetById",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EntityServer).GetById(ctx, req.(*proto.Id64Request))
	}
	return interceptor(ctx, in, info, handler)
}

func _Entity_Count_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EntityServer).Count(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/treeMs.Entity/Count",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EntityServer).Count(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Entity_GetByType_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.StringRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EntityServer).GetByType(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/treeMs.Entity/GetByType",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EntityServer).GetByType(ctx, req.(*proto.StringRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Entity_ListByParentId_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListByParentIdReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EntityServer).ListByParentId(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/treeMs.Entity/ListByParentId",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EntityServer).ListByParentId(ctx, req.(*ListByParentIdReq))
	}
	return interceptor(ctx, in, info, handler)
}

// Entity_ServiceDesc is the grpc.ServiceDesc for Entity service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Entity_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "treeMs.Entity",
	HandlerType: (*EntityServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Entity_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Entity_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Entity_Delete_Handler,
		},
		{
			MethodName: "GetById",
			Handler:    _Entity_GetById_Handler,
		},
		{
			MethodName: "Count",
			Handler:    _Entity_Count_Handler,
		},
		{
			MethodName: "GetByType",
			Handler:    _Entity_GetByType_Handler,
		},
		{
			MethodName: "ListByParentId",
			Handler:    _Entity_ListByParentId_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "entity.proto",
}
